package at.jku.ssw.map.test;

import org.junit.Assert;
import org.junit.Test;

import at.jku.ssw.map.Map;

public abstract class SizeRestrictedMapTest extends MapTest {

	public abstract int tableSize();

	@Test
	public void testTableFull() {
		Map map = createMap();
		int tableSize = tableSize();
		for (int i = 0; i < tableSize; i++) {
			Object key = new Object();
			map.put(key, key);
		}
		Assert.assertEquals(tableSize, map.size());
		Object key = new Object();
		thrown.expect(IllegalStateException.class);
		map.put(key, key);
	}

	@Test
	public void testTableFullDeleted() {
		Map map = createMap();
		int tableSize = tableSize();
		Object key = null;
		for (int i = 0; i < tableSize; i++) {
			key = String.valueOf(i);
			map.put(key, key);
		}
		Assert.assertEquals(tableSize, map.size());
		Object e = map.remove(key);
		Assert.assertEquals(key, e);
		Assert.assertEquals(tableSize - 1, map.size());
		key = new Object();
		map.put(key, key);
		Assert.assertEquals(tableSize, map.size());
	}

	@Test
	public void testTableFullNotContained() {
		Map map = createMap();
		int tableSize = tableSize();
		for (int i = 0; i < tableSize; i++) {
			Object key = String.valueOf(i);
			map.put(key, key);
		}
		Object key = new Object();
		Assert.assertEquals(tableSize, map.size());
		Assert.assertFalse(map.containsKey(key));

		Object e = map.get(key);
		Assert.assertEquals(null, e);
		Assert.assertEquals(tableSize, map.size());

		e = map.remove(key);
		Assert.assertEquals(null, e);
		Assert.assertEquals(tableSize, map.size());
	}
}